program hist_2D

  implicit none
  
  character*80 :: input = 'finance.dat'
  character*80 :: output = 'hist_finance.dat'
  
  integer,dimension(2) :: nbin = (/ 30 , 30 /)
  real,allocatable :: hist(:,:)
  real,allocatable :: axis1(:)
  real,allocatable :: axis2(:)
  
  integer,dimension(2) :: ind
  integer ndp,ios,i,j,k
  real,allocatable :: x(:,:)
  real,dimension(2) :: mini,maxi,dx
  real norm,x0
  
  allocate( hist(nbin(1),nbin(2)) )
  allocate( axis1(nbin(1)) , axis2(nbin(2)) )
  
  print*, ' '
  print*, 'Lese Daten ...'
  
  open(10,file=input,status='old')
  
  ndp = -1
  ios = 0
  
  do while (ios==0)
    read(10,*,iostat=ios) x0
    ndp=ndp+1 
  end do
  
  rewind(10)
  
  print*, ndp, 'Datenpunkte'
  
  allocate(x(2,ndp))
  
  do i=1,ndp
    read(10,*) x(1,i) , x(2,i)
  end do
  
  close(10)
  print*, 'Fertig.'
  
  mini = x(:,1)
  maxi = x(:,1)
  
  do i=2,ndp
    do j=1,2
      if ( x(j,i)<mini(j) ) mini(j) = x(j,i)
      if ( x(j,i)>maxi(j) ) maxi(j) = x(j,i)
    end do
  end do
  
  mini = mini - (maxi-mini)*0.1
  maxi = maxi + (maxi-mini)*0.1
  
  print*, 'Minimum:', mini
  print*, 'Maximum:', maxi
  print*, ''
  print*, 'Bestimme Koordinatenachse ...'
  
  dx = (maxi - mini)/real(nbin-1)
  
  do i=1,nbin(1)
    axis1(i) = mini(1) + (real(i-1) + 0.5)*dx(1)
  end do

  do i=1,nbin(2)
    axis2(i) = mini(2) + (real(i-1) + 0.5)*dx(2)
  end do
  print*, 'Fertig.'
  
  hist = 0.0
  
  do i=1,ndp
  
    ind = int( (x(:,i) - mini)/dx ) + 1
    hist(ind(1),ind(2)) = hist(ind(1),ind(2)) + 1.0
  
  end do
  
  hist = hist/(real(ndp)*dx(1)*dx(2))
  
  norm = 0.0
  
  print*, ''
  print*, 'Schreibe Ergebnis in Datei ...'
  
  open(12,file=output,status='replace')
  do i=1,nbin(1)
    do j=1,nbin(2)
      write(12,*) axis1(i) , axis2(j) , hist(i,j)
      norm = norm + hist(i,j)
    end do
    write(12,*) ' '
  end do
  norm = norm*dx(1)*dx(2)
  print*, 'Fertig.'
  
  print*, 'Norm: ', norm
  
end program













